	.text
	.global _cpsr_read
_cpsr_read:
	mrs		r0, cpsr
	mov		pc, lr

	.global _cpsr_write
_cpsr_write:
	msr		cpsr, r0
	mov		pc, lr
				
	.global _cp15_write_control_register
_cp15_write_control_register:
	mcr		p15, 0, r0, c1, c0, 0
	mov		r3, r3
	mov		r3, r3
	mov		r3, r3
	mov		pc, lr

	.global _cp15_read_control_register
_cp15_read_control_register:
	mrc		p15, 0, r0, c1, c0, 0
	mov		pc, lr

	.global _cp15_write_translation_table_base
_cp15_write_translation_table_base:
	mcr		p15, 0, r0, c2, c0, 0
	mov		pc, lr

	.global _cp15_write_domain_access_control
_cp15_write_domain_access_control:
	mcr		p15, 0, r0, c3, c0, 0
	mov		pc, lr

	.global _enable_I_cache
_enable_I_cache:
	stmdb	sp!, {r0, lr}
	mov		r0, #0
	mcr		p15, 0, r0, c7, c6, 0		@ invalidate D cache
	mcr		p15, 0, r0, c7, c5, 0		@ invalidate I cache
	mcr		p15, 0, r0, c7, c10, 4		@ drain WB

	mrc		p15, 0, r0, c1, c0, 0		// read ctrl register
	orr		r0, r0, #0x01000			// ...i............
	mcr		p15, 0, r0, c1, c0, 0		// write ctrl register

	ldmia	sp!, {r0, pc}


	.global _enable_caches
_enable_caches:
	stmdb	sp!, {r0, lr}
	mov		r0, #0
	mcr		p15, 0, r0, c7, c6, 0		@ invalidate D cache
	mcr		p15, 0, r0, c7, c5, 0		@ invalidate I cache
	mcr		p15, 0, r0, c7, c10, 4		@ drain WB

	mrc		p15, 0, r0, c1, c0, 0		// read ctrl register
	orr		r0, r0, #0x00004			// .............c..
	orr		r0, r0, #0x01000			// ...i............
	mcr		p15, 0, r0, c1, c0, 0		// write ctrl register

	ldmia	sp!, {r0, pc}


	.global _disable_caches
	.align 5
_disable_caches:
	stmdb	sp!, {r1, r3, lr}
#undef CONFIG_CPU_ARM920_FORCE_WRITE_THROUGH
#ifdef CONFIG_CPU_ARM920_FORCE_WRITE_THROUGH
	mcr		p15, 0, r0, c7, c6, 0		@ invalidate D cache
#else
		/*
		 * 'Clean & Invalidate whole DCache'
		 * Re-written to use Index Ops.
		 * Uses registers r1, r3 and r4
		 */
	mov		r1, #7 << 5				@ 8 segments
1:	orr		r3, r1, #63 << 26			@ 64 entries
2:	mcr		p15, 0, r3, c7, c14, 2		@ clean & invalidate D index
	subs	r3, r3, #1 << 26
	bcs		2b							@ entries 63 to 0
	subs	r1, r1, #1 << 5
	bcs		1b							@ segments 7 to 0
#endif
	mov		r1, #0
	mcr		p15, 0, r1, c7, c5, 0		@ invalidate I cache
	mcr		p15, 0, r1, c7, c10, 4		@ drain WB
	mcr		p15, 0, r1, c8, c7, 0       @ invalidate I & D TLBs

	mrc		p15, 0, r1, c1, c0, 0		// read ctrl register
	bic		r1, r1, #0x00004			// .............c..
	bic		r1, r1, #0x01000			// ...i............
	mcr		p15, 0, r1, c1, c0, 0		// write ctrl register

	ldmia	sp!, {r1, r3, pc}


	.global _boot_linux_kernel // (unsigned boot_addr)
_boot_linux_kernel:
	mov r2, r0
	mov r0, #0						// kernel wants r0 to be 0
	mov r1, #90						// r1 is arch no for this machine
	mov pc, r2						// bye bye

	.global _disable_mmu
	.align 5
_disable_mmu:
	stmdb	sp!, {r1, lr}

	mrc		p15, 0, r1, c1, c0, 0		// read ctrl register
	bic		r1, r1, #0x00001			// ...............m
	mcr		p15, 0, r1, c1, c0, 0		// write ctrl register

	nop
	nop
	ldmia	sp!, {r1, pc}

