/*******************************************************
 *
 *  File: crc.c
 *
 *  Author: Peter van Sebille (peter@yipton.demon.co.uk)
 *
 *  (c) Copyright 2001, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************/

#include "crc.h"

/******************************************
 *
 * CRC checks
 *
 *****************************************/


#define		MTT	0x1021		/* crc-ccitt mask */

static unsigned update_crc(unsigned crc, int c, unsigned mask)
{
	int i;
	c<<=8;
	for(i=0;i<8;i++)
	{
		if((crc ^ c) & 0x8000) crc=(crc<<1)^mask;
		else crc<<=1;
		c<<=1;
	}
	return crc;
}

unsigned crc_data(const char* data, int count, unsigned crc16)
{
	while(count--)
	{
		crc16 = update_crc(crc16, *data++, MTT);
	}
	return crc16;
}


