/*******************************************************
 *
 *  File: lib.h
 *
 *  Author: Peter van Sebille (peter@yipton.demon.co.uk)
 *
 *  (c) Copyright 2001, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************/

#ifndef __LIB_H
#define __LIB_H

#include <stdarg.h>

#ifndef NULL
#define NULL ((void*) 0)
#endif

unsigned lib_bits(unsigned reg, int first, int last);
unsigned lib_bit(unsigned reg, int bit);


int lib_strlen(const char* str);
char* lib_strcpy(char* dst, const char* src);
char* lib_memcpy(char* dst, const char* src, int len);
char* lib_itoa_hex(unsigned num, char* str);
char* lib_strcat(char* dst, const char* src);
int   lib_strncmp(const char*, const char*, int len);

char* lib_my_atoi(char* buf, int* i);

int lib_sprintf(char* buf, const char* fmt, ...);
int lib_vsprintf(char* buf, const char* fmt, va_list args);


#endif			/* __LIB_H */

